/*
 * Server.java
 *
 * Created on 22. nor 2005, 20:21
 */

package cz.vse.xkucf03.chat.server;

import cz.vse.xkucf03.chat.ChatVyjimka;
import cz.vse.xkucf03.chat.KlientRozhrani;
import cz.vse.xkucf03.chat.ServerRozhrani;
import cz.vse.xkucf03.chat.Uzivatel;
import cz.vse.xkucf03.chat.Zprava;
import java.util.ArrayList;

/**
 *
 * @author fiki
 */
public class Server extends java.rmi.server.UnicastRemoteObject implements ServerRozhrani {
    
    /** Creates a new instance of Server */
    public Server()  throws java.rmi.RemoteException  {
        
        seznamVsechUzivatelu = new UzivatelLogin[2];
        seznamVsechUzivatelu[0] = new UzivatelLogin(1, "loginY", "Zkuebn uivatel", "heslo");
        seznamVsechUzivatelu[1] = new UzivatelLogin(2, "loginX", "Zkuebn uivatel X", "heslo");
        
    }
    
    /**
     * vrac token - slou pro oven dalch poadavk klienta
     * po pihlen odele server klientovi historii zprv pro nj
     */
    public String prihlasKlienta(String login, String heslo, int klic) throws ChatVyjimka, java.rmi.RemoteException {
        System.out.println("Server_prihlasKlienta: zatek pihlaovn");
        KlientRozhrani k = null;
        String token = null;
        
        
        for (int i = 0; i < seznamVsechUzivatelu.length; i ++) {
            System.out.println("Server_prihlasKlienta: zatek cyklu seznamVsechUzivatelu");
            
            token = seznamVsechUzivatelu[i].getToken(login, heslo);
            
            if (token != null) {
                System.out.println("Server_prihlasKlienta: token != null");
                seznamVsechUzivatelu[i].setKlic(klic);
                
                try {
                    System.out.println("Server_prihlasKlienta: lookup klienta zahjen");
                    k  = (KlientRozhrani)java.rmi.Naming.lookup("rmi://localhost:1099/Klient_" + seznamVsechUzivatelu[i].getLogin());
                    System.out.println("Server_prihlasKlienta: lookup klienta dokonen");
                } catch (Exception e){
                    System.out.println("Chyba: " + e);
                }
                
                System.out.println("Server_prihlasKlienta: nastavme odkaz na klienta do seznamuVsechUzivatelu");
                seznamVsechUzivatelu[i].setKlient(k);
                
                System.out.println("Server_prihlasKlienta: pidme uivatele do seznamuPrihlench");
                seznamPrihlasenych.add(seznamVsechUzivatelu[i]);
                
                System.out.println("Server_prihlasKlienta: vrtme token: " + token);
                return token;
            }
        }
        
        System.out.println("Server_prihlasKlienta: vrtme null");
        return null;
        //return "testovac_token!!!"; // vrtme tkonen, i kdy uivatel neexistuje - pro ely testovn
    }
    
    public void posliZpravu(String token, Zprava z) throws ChatVyjimka, java.rmi.RemoteException {
        String[] komu = z.getKomu();
        
        //poleme zprvu vem pjemcm
        for (int i = 0; i < komu.length; i++) {
            for (int ii = 0; ii < seznamPrihlasenych.size(); ii++) {
                
                if (((UzivatelLogin)seznamPrihlasenych.get(ii)).getLogin().equals(komu[i])) {
                    ((UzivatelLogin)seznamPrihlasenych.get(ii)).getKlient().prijmiZpravu(((UzivatelLogin)seznamPrihlasenych.get(ii)).getKlic(), z);
                    break;
                }
                
                
            }
        }
        
        
    }
    
    public Uzivatel[] getSeznamPrihlasenych() throws ChatVyjimka, java.rmi.RemoteException {
        Uzivatel[] seznam = new Uzivatel[seznamPrihlasenych.size()];
        for (int i = 0; i < seznamPrihlasenych.size(); i++) {
            seznam[i] = ((UzivatelLogin)seznamPrihlasenych.get(i)).getUzivatel();
        }
        
        return seznam;
        
    }
    
    private ArrayList seznamPrihlasenych = new ArrayList();
    
    /** seznam vech - i nepihlench - uivatel */
    private UzivatelLogin[] seznamVsechUzivatelu;
    
    
    
}
