/*
 * UzivatelLogin.java
 *
 * Created on 22. nor 2005, 19:55
 */

package cz.vse.xkucf03.chat.server;

import cz.vse.xkucf03.chat.ChatVyjimka;
import cz.vse.xkucf03.chat.KlientRozhrani;
import cz.vse.xkucf03.chat.Uzivatel;

/**
 *
 * @author fiki
 */
public class UzivatelLogin extends cz.vse.xkucf03.chat.Uzivatel {
    
    /**
     * Holds value of property heslo.
     */
    private String heslo;

    /**
     * Holds value of property token.
     */
    private String token;

    /**
     * Holds value of property klic.
     */
    private int klic;

    /**
     * Holds value of property klient.
     */
    private KlientRozhrani klient;
    
    /** Creates a new instance of UzivatelLogin */
    public UzivatelLogin() {
    }
    
    /**
     * Getter for property heslo.
     * @return Value of property heslo.
     */
    public String getHeslo() {
        
        return this.heslo;
    }
    
    /**
     * Setter for property heslo.
     * @param heslo New value of property heslo.
     */
    public void setHeslo(String heslo) {
        
        this.heslo = heslo;
    }
    
    /** Vrt instanci tdy Uzivatel - objekt, kter neobsahuje heslo */
    public Uzivatel getUzivatel() {
        return new Uzivatel(0, getLogin(), getCeleJmeno());
    }
    
    public UzivatelLogin(int id, String login, String celeJmeno, String heslo) {
        super(id, login, celeJmeno);
        setHeslo(heslo);
        
    }
    
    public String getToken(String login, String heslo) {
        if ((login.equals(this.getLogin())) && (this.heslo.equals(heslo))) {
            
            setToken(login + "_" + new java.util.Random().nextInt());
            return getToken();
            
        } else {
            return null;
            
        }
    }

    /**
     * Getter for property token.
     * @return Value of property token.
     */
    public String getToken() {

        return this.token;
    }

    /**
     * Setter for property token.
     * @param token New value of property token.
     */
    public void setToken(String token) {

        this.token = token;
    }

    /**
     * Getter for property klic.
     * @return Value of property klic.
     */
    public int getKlic() {

        return this.klic;
    }

    /**
     * Setter for property klic.
     * @param klic New value of property klic.
     */
    public void setKlic(int klic) {

        this.klic = klic;
    }

    /**
     * Getter for property klient.
     * @return Value of property klient.
     */
    public KlientRozhrani getKlient() {

        return this.klient;
    }

    /**
     * Setter for property klient.
     * @param klient New value of property klient.
     */
    public void setKlient(KlientRozhrani klient) {

        this.klient = klient;
    }
    
}
